import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopMerchantApply, ShopMerchantApplyParam } from './model';

/**
 * 分页查询商户入驻申请
 */
export async function pageShopMerchantApply(params: ShopMerchantApplyParam) {
  const res = await request.get<ApiResult<PageResult<ShopMerchantApply>>>(
    '/shop/shop-merchant-apply/page',
    params
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询商户入驻申请列表
 */
export async function listShopMerchantApply(params?: ShopMerchantApplyParam) {
  const res = await request.get<ApiResult<ShopMerchantApply[]>>(
    '/shop/shop-merchant-apply',
    params
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加商户入驻申请
 */
export async function addShopMerchantApply(data: ShopMerchantApply) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-merchant-apply',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改商户入驻申请
 */
export async function updateShopMerchantApply(data: ShopMerchantApply) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-merchant-apply',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

// 审核通过
export async function checkShopMerchantApply(data: ShopMerchantApply) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-merchant-apply/check',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除商户入驻申请
 */
export async function removeShopMerchantApply(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-merchant-apply/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除商户入驻申请
 */
export async function removeBatchShopMerchantApply(
  data: (number | undefined)[]
) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/shop-merchant-apply/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询商户入驻申请
 */
export async function getShopMerchantApply(id: number) {
  const res = await request.get<ApiResult<ShopMerchantApply>>(
    '/shop/shop-merchant-apply/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
